do

  local function ChangeBuildRate(id,bp,new)
    local name = bp.Description or bp.Interface.HelpText or bp.General.UnitName
    LOG("Adjusting BuildRate of "..id.." ("..name..") from "..bp.Economy.BuildRate.." to "..new)
    bp.Economy.BuildRate = new
  end

  local oldModBlueprints = ModBlueprints

  function ModBlueprints(all_bps)
    oldModBlueprints(all_bps)

    LOG("Entering hooked ModBlueprints")
    for id,bp in all_bps.Unit do
      if (bp.Economy.BuildRate) then
--        LOG("Examining unit "..id)
        local categories = {}
        for i,cat in ipairs(bp.Categories) do
  --        LOG("Has category "..cat)
          categories[cat] = true
        end
  
        if (categories.STRUCTURE and not categories.GATE) then
          if     (categories.TECH2 and categories.FACTORY) then
            ChangeBuildRate(id,bp,50)
          elseif (categories.TECH3 and categories.FACTORY) then
            ChangeBuildRate(id,bp,180)
          end
        elseif (categories.EXPERIMENTAL and categories.FACTORY) then
          ChangeBuildRate(id,bp,bp.Economy.BuildRate * 2)
        elseif (categories.CARRIER and categories.FACTORY) then
          ChangeBuildRate(id,bp,240)
        end
      end
    end
  end

end
